<?php /*
Plugin Name: RV thumbs
Version: 2.0.a
Description: Let users see a variable number of thumbnails on the index page
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=261
Author: rvelices
Author URI: http://www.modusoptimus.com/
*/

define('RV_THUMBS_MAX', 384);

add_event_handler('loc_begin_index', 'rv_thumbs_begin_index' );

function rv_thumbs_begin_index()
{
	global $page;
	$multiplier = pwg_get_session_var('idx_thumbs_muliplier', 1);
	if (isset($_GET['thumbs']))
	{
		$page['meta_robots']['noindex']=1;
		switch ($_GET['thumbs'])
		{
			case 'more':
				$multiplier = ($multiplier==1) ? 4 : $multiplier*2;
				$multiplier = min($multiplier, ceil(RV_THUMBS_MAX/$page['nb_image_page']));
				break;
			case 'less':
				$multiplier = ($multiplier==4) ? 1 : (int)$multiplier/2;
				$multiplier = max(1, $multiplier);
				break;
		}
		if ($multiplier>1)
			pwg_set_session_var('idx_thumbs_muliplier', $multiplier);
		else
			pwg_unset_session_var('idx_thumbs_muliplier');
	}
	$page['nb_image_page'] *= $multiplier;
	global $user; $user['nb_image_page'] *= $multiplier; // TEMP
	if ( count($page['items']) )
		add_event_handler('loc_end_index', 'rv_thumbs_end_index' );
}

function rv_thumbs_end_index()
{
	global $user, $template, $page;
	$multiplier = pwg_get_session_var('idx_thumbs_muliplier', 1);
	$nav_bar = & $template->get_template_vars('NAV_BAR');
	$ini_per_page = $user['nb_image_line'] * $user['nb_line_page']; //TEMP
	$has_less = $multiplier>1 && count($page['items'])>$ini_per_page;
	$has_more = !empty($nav_bar) && $multiplier < ceil(RV_THUMBS_MAX/$ini_per_page );
	if ($has_less || $has_more)
	{
		$nav_bar .= !empty($nav_bar) ? ' &nbsp; ' : '';
		if ($has_less)
		 $nav_bar .= '<a href="'.add_url_params(duplicate_index_url(), array('thumbs'=>'less')).'" rel="nofollow">Less</a>';
		else
		 $nav_bar .= 'Less';
		$nav_bar .= ' | ';
		if ($has_more)
		 $nav_bar .= '<a href="'.add_url_params(duplicate_index_url(array('start'=>0)), array('thumbs'=>'more')).'" rel="nofollow">More</a>';
		else
		 $nav_bar .= 'More';
	}
}
?>